## ocsigen 1.3.4

=== Makefile ===
include Makefile.config

VERSION := $(shell head -n 1 VERSION)

DOCPREF=./

# sed commands used for generation of META files
SED_COMMAND_FOR_META =
SED_COMMAND_FOR_META += -e "s/_VERSION_/$(VERSION)/"
SED_COMMAND_FOR_META += -e "s/_CAMLZIPNAME_/$(CAMLZIPNAME)/"
SED_COMMAND_FOR_META += -e "s@_DIRECTORY_@$(MODULEINSTALLDIR)/$(OCSIGENNAME)@"

ifeq "$(OCAMLDUCE)" "YES"
DUCECMA=eliom/eliom_duce.cma
DUCECMO=
#eliom/eliom_duce.cma
# eliom/ocsigenrss.cma
DUCECMI=eliom/eliom_duce.cmi eliom/xhtmltypes_duce.cmi eliom/eliom_duce_tools.cmi
# eliom/rss2.cmi eliom/ocsigenrss.cmi
DUCEEXAMPLES=examples/ocamlduce/exampleduce.cmo
# examples/ocamlduce/examplerss.cmo
DUCEDOC=$(DOCPREF)eliom/eliom_duce.mli $(DOCPREF)eliom/xhtmltypes_duce.ml $(DOCPREF)eliom/eliom_duce_tools.ml
CAMLDOC = $(OCAMLDUCEFIND) ocamldoc $(LIB)
DUCEPACK=,ocamlduce
else
DUCECMA=
DUCECMO=
DUCECMI=
DUCEEXAMPLES=
DUCEDOC=
CAMLDOC = $(OCAMLFIND) ocamldoc $(LIB)
DUCEPACK=
endif

ifeq "$(LOGDIR)" ""
LOGDIR = "error"
endif
ifeq "$(STATICPAGESDIR)" ""
STATICPAGESDIR = "error"
endif
ifeq "$(DATADIR)" ""
DATADIR = "error"
endif

ifeq "$(OCSIPERSISTSQLITE)" "YES"
SQLITECMATOINSTALL= extensions/ocsipersist-sqlite.cma
else
endif

ifeq "$(CAMLZIP)" "YES"
DEFLATEMODCMOTOINSTALL= extensions/deflatemod.cmo
else
endif

ifeq "$(OCSIPERSISTDBM)" "YES"
DBMCMATOINSTALL= extensions/ocsipersist-dbm/ocsipersist-dbm.cma 
else
endif

DOC= $(DOCPREF)eliom/eliom_mkforms.mli $(DOCPREF)eliom/eliom_mkreg.mli	\
	$(DOCPREF)eliom/eliom_predefmod.mli				\
	$(DOCPREF)eliom/eliom_common.mli				\
	$(DOCPREF)eliom/eliom_parameters.mli				\
	$(DOCPREF)eliom/eliom_services.mli				\
	$(DOCPREF)eliom/eliom_sessions.mli				\
	$(DOCPREF)eliom/eliom_extensions.mli				\
	$(DOCPREF)server/ocsigen_extensions.mli				\
	$(DOCPREF)server/ocsigen_parseconfig.mli			\
	$(DOCPREF)server/ocsigen_server.mli				\
	$(DOCPREF)xmlp4/xhtmlpretty_streams.mli				\
	$(DOCPREF)xmlp4/xhtmlcompact_streams.mli			\
	$(DOCPREF)xmlp4/xhtmlpretty.mli					\
	$(DOCPREF)xmlp4/xhtmlcompact.mli				\
	$(DOCPREF)xmlp4/ohl-xhtml/xHTML.mli				\
	$(DOCPREF)baselib/ocsigen_messages.mli				\
	$(DOCPREF)http/ocsigen_headers.mli				\
	$(DOCPREF)server/ocsigen_http_client.mli			\
	$(DOCPREF)http/ocsigen_http_frame.mli				\
	$(DOCPREF)http/ocsigen_http_com.mli				\
	$(DOCPREF)http/ocsigen_charset_mime.mli				\
	$(DOCPREF)http/ocsigen_senders.mli				\
	$(DOCPREF)baselib/ocsigen_stream.mli				\
	$(DOCPREF)eliom/eliom_tools_common.mli			 	\
	$(DOCPREF)eliom/eliom_tools.mli					\
	$(DOCPREF)eliom/eliom_obrowser.mli					\
	$(DOCPREF)baselib/polytables.mli				\
	$(DOCPREF)baselib/ocsigen_cache.mli				\
	$(DOCPREF)extensions/ocsipersist.mli				\
	$(DOCPREF)extensions/authbasic.mli				\
	$(DOCPREF)extensions/ocsigen_LocalFiles.mli			\
	$(DOCPREF)baselib/ocsigen_getcommandline.mli                    \
	$(DOCPREF)xmlp4/newocaml/pp/simplexmlparser.mli			\
	$(DOCPREF)xmlp4/newocaml/pp/xhtmltypes.ml			\
	$(DUCEDOC)

METAS = files/META files/META.ocsigen_xhtml files/META.ocsigen files/META.eliom_examples files/META.eliom_examples.global


INSTALL = install
TARGETSBYTE = baselib.byte xmlp4.byte http.byte server.byte extensions.byte eliom.byte examples.byte

# plugins are cma (and cmxs) that can be loaded dynamically by the server
PLUGINSCMATOINSTALL = $(SQLITECMATOINSTALL) $(DBMCMATOINSTALL) \
	eliom/eliom.cma $(DEFLATEMODCMATOINSTALL) $(DUCECMA) \
	baselib/parsecommandline.cma baselib/donotparsecommandline.cma
PLUGINSCMOTOINSTALL = \
	$(SQLITECMOTOINSTALL) $(DBMCMOTOINSTALL) $(DEFLATEMODCMOTOINSTALL) \
	extensions/staticmod.cmo extensions/cgimod.cmo \
        extensions/revproxy.cmo extensions/userconf.cmo \
        extensions/outputfilter.cmo extensions/authbasic.cmo \
	extensions/redirectmod.cmo extensions/rewritemod.cmo \
	extensions/accesscontrol.cmo extensions/extendconfiguration.cmo \
	baselib/polytables.cmo $(DUCECMO)
PLUGINSCMITOINSTALL = extensions/ocsipersist.cmi \
       eliom/eliom_mkforms.cmi eliom/eliom_mkreg.cmi \
       eliom/eliom_tools_common.cmi eliom/eliom_tools.cmi \
       eliom/eliom_obrowser.cmi \
       $(DUCECMI) \
       eliom/eliom_sessions.cmi eliom/eliom_parameters.cmi \
       eliom/eliom_services.cmi eliom/eliom_predefmod.cmi \
       eliom/eliommod.cmi eliom/eliom_common.cmi eliom/eliom_extensions.cmi \
       extensions/accesscontrol.cmi extensions/extendconfiguration.cmi \
       baselib/polytables.cmi

# Put here only those which do not have cmxs (Vincent: Why?)
CMATOINSTALL = xmlp4/xhtmlsyntax.cma xmlp4/xhtmlpretty.cma	\
	xmlp4/ohl-xhtml/xhtml.cma server/ocsigen.cma
CMOTOINSTALL = server/server_main.cmo
CMITOINSTALL = baselib/ocsigen_getcommandline.cmi			\
	server/ocsigen_extensions.cmi server/ocsigen_parseconfig.cmi	\
	server/ocsigen_server.cmi server/ocsigen_http_client.cmi	\
	xmlp4/xhtmlpretty.cmi xmlp4/xhtmlpretty_streams.cmi		\
	xmlp4/xhtmlcompact.cmi xmlp4/ohl-xhtml/xHTML.cmi		\
	xmlp4/ohl-xhtml/xML.cmi xmlp4/xhtmltypes.cmi			\
	xmlp4/simplexmlparser.cmi http/ocsigen_charset_mime.cmi		\
	http/ocsigen_senders.cmi http/framepp.cmi			\
	http/ocsigen_http_com.cmi http/http_headers.cmi			\
	baselib/ocsigen_cache.cmi                                       \
	baselib/ocsigen_lib.cmi baselib/ocsigen_config.cmi		\
	http/ocsigen_http_frame.cmi http/ocsigen_headers.cmi		\
	baselib/ocsigen_stream.cmi baselib/ocsigen_messages.cmi		\
	extensions/ocsigen_LocalFiles.cmi files/META
EXAMPLESCMO = examples/tutoeliom.cmo examples/monitoring.cmo	\
	examples/miniwiki/miniwiki.cmo $(DUCEEXAMPLES)

EXAMPLESCMI = examples/tutoeliom.cmi

ifeq "$(BYTECODE)" "YES"
TOINSTALLBYTE=$(CMATOINSTALL) $(CMOTOINSTALL)\
	      $(PLUGINSCMATOINSTALL) $(PLUGINSCMOTOINSTALL)
PLUGINSTOINSTALLBYTE=$(PLUGINSCMATOINSTALL) $(PLUGINSCMOTOINSTALL)
EXAMPLESBYTE=$(EXAMPLESCMO)
BYTE=byte
else
TOINSTALLBYTE=
PLUGINSTOINSTALLBYTE=
EXAMPLESBYTE=
BYTE=
endif

ifeq "$(NATDYNLINK)" "YES"
CMXS=$(PLUGINSCMOTOINSTALL:.cmo=.cmxs) $(PLUGINSCMATOINSTALL:.cma=.cmxs)
EXAMPLECMXS=$(EXAMPLESCMO:.cmo=.cmxs)
else
CMXS=
EXAMPLECMXS=
endif

ifeq "$(NATIVECODE)" "YES"
PLUGINSTOINSTALLX=$(CMXS)

TOINSTALLXTEMP=$(CMAOTOINSTALL:.cmo=.cmx)
TOINSTALLX=$(CMATOINSTALL:.cma=.cmxa) \
           $(CMATOINSTALL:.cma=.a) \
	   $(CMOTOINSTALL:.cmo=.cmx) \
	   $(CMOTOINSTALL:.cmo=.o) \
	   $(PLUGINSCMOTOINSTALL:.cmo=.cmx) \
	   $(PLUGINSCMOTOINSTALL:.cmo=.o) \
	   $(PLUGINSCMATOINSTALL:.cma=.cmxa) \
	   $(PLUGINSCMATOINSTALL:.cma=.a)
EXAMPLESOPT=$(EXAMPLECMXS)
OPT=opt
DEPOPT=xmlp4pre.opt
else
TOINSTALLX=
PLUGINSTOINSTALLX=
EXAMPLESOPT=
OPT=
endif

STATICSTUBS = server/lib$(OCSIGENNAME).a

PLUGINSTOINSTALL=$(PLUGINSTOINSTALLBYTE) $(PLUGINSTOINSTALLX)
TOINSTALL=$(TOINSTALLBYTE) $(TOINSTALLX) $(CMITOINSTALL) $(PLUGINSCMITOINSTALL) $(PLUGINSTOINSTALL) $(STATICSTUBS) eliom/pa_eliom_obrowser.cmo eliom/obrowser/_build/eliom_obrowser_client.cma eliom/obrowser/_build/eliom_obrowser_client.cmi eliom/obrowser/_build/lwt_obrowser.cmi eliom/obrowser/eliom_obrowser.js
EXAMPLES=$(EXAMPLESBYTE) $(EXAMPLESOPT) $(EXAMPLESCMI)

REPS=$(TARGETSBYTE:.byte=)
STD_METAS_DIR=$(MODULEINSTALLDIR)

all: $(BYTE) $(OPT) $(OCSIGENNAME).conf.local $(METAS)

byte: xmlp4pre.byte $(TARGETSBYTE)

opt: xmlp4pre.opt $(TARGETSBYTE:.byte=.opt)

.PHONY: $(REPS) clean distclean


baselib: baselib.byte

baselib.byte:
	$(MAKE) -C baselib byte

baselib.opt:
	$(MAKE) -C baselib opt

xmlp4: xmlp4.byte

xmlp4.byte:
#	touch xmlp4/.depend
#	$(MAKE) -C xmlp4 depend
	$(MAKE) -C xmlp4 byte

xmlp4pre.byte:
#	$(MAKE) -C xmlp4 depend
	$(MAKE) -C xmlp4 xmlp4pre.byte

xmlp4pre.opt:
	$(MAKE) -C xmlp4 xmlp4pre.opt

xmlp4.opt:
#	touch xmlp4/.depend
#	$(MAKE) -C xmlp4 depend
	$(MAKE) -C xmlp4 opt

http: http.byte

http.byte:
	$(MAKE) -C http byte

http.opt:
	$(MAKE) -C http opt

extensions: extensions.byte

extensions.byte:
	$(MAKE) -C extensions byte

extensions.opt:
	$(MAKE) -C extensions opt

eliom: eliom.byte

eliom.byte:
	$(MAKE) -C eliom byte

eliom.opt:
	$(MAKE) -C eliom opt

examples: examples.byte

examples.byte:
	$(MAKE) -C examples byte

examples.opt:
	$(MAKE) -C examples opt

server: server.byte

server.byte:
	$(MAKE) -C server byte

server.opt:
	$(MAKE) -C server opt

doc:
	$(CAMLDOC) -package lwt.ssl,netstring$(DUCEPACK) $(LIBDIRS3) -I `$(CAMLP4) -where` -I +threads -intro files/indexdoc -d doc -html $(DOC)

doc/index.html: doc

files/META: files/META.in VERSION
	sed $(SED_COMMAND_FOR_META) < $< > $@

files/META.ocsigen_xhtml: files/META.ocsigen_xhtml.in VERSION
	sed $(SED_COMMAND_FOR_META) < $< > $@

files/META.ocsigen: files/META.in VERSION
	-ln -sf ../eliom/eliom.cma extensions
	-ln -sf ../eliom/eliom_duce.cma extensions
	-ln -sf ../eliom/obrowser/_builde/eliom_obrowser_client.cma extensions
	-ln -sf ../eliom/obrowser/_build/lwt_obrowser.cmo extensions
	-ln -sf ../xmlp4/ohl-xhtml/xhtml.cma extensions
	-ln -sf ../xmlp4/xhtmlpretty.cma extensions
	-ln -sf ../xmlp4/xhtmlsyntax.cma extensions
	-ln -sf ../eliom/eliom.cmxa extensions
	-ln -sf ../eliom/eliom_duce.cmxa extensions
	-ln -sf ../xmlp4/ohl-xhtml/xhtml.cmxa extensions
	-ln -sf ../xmlp4/xhtmlpretty.cmxa extensions
	-ln -sf ../xmlp4/xhtmlsyntax.cmxa extensions
	-ln -sf ../eliom/eliom.cmxs extensions
	-ln -sf ../eliom/eliom_duce.cmxs extensions
	-ln -sf ../xmlp4/ohl-xhtml/xhtml.cmxs extensions
	-ln -sf ../xmlp4/xhtmlpretty.cmxs extensions
	-ln -sf ../xmlp4/xhtmlsyntax.cmxs extensions
	-ln -sf ../baselib/parsecommandline.cma extensions
	-ln -sf ../baselib/donotparsecommandline.cma extensions
	echo directory = \"$(SRC)/extensions\" > $@
	sed $(SED_COMMAND_FOR_META) -e "s%_MODULEINSTALLDIR_%$(SRC)/extensions%g" < $< >> $@
#	sed "s%\"xhtml\" (%\"xhtml\" (\n  directory = \"$(SRC)/xmlp4/ohl-xhtml/\"%g" >> $@

files/META.eliom_examples: files/META.eliom_examples.in VERSION
	sed $(SED_COMMAND_FOR_META) -e "s%_EXAMPLESINSTALLDIR_%$(SRC)/examples%g" < $< > $@

files/META.eliom_examples.global: files/META.eliom_examples.in VERSION
	sed $(SED_COMMAND_FOR_META) -e "s%_EXAMPLESINSTALLDIR_%$(EXAMPLESINSTALLDIR)%g"< $< > $@

$(OCSIGENNAME).conf.local: Makefile.config files/ocsigen.conf.in
	cat files/ocsigen.conf.in \
	| sed s%\<port\>80\</port\>%\<port\>8080\</port\>%g \
	| sed s%_LOGDIR_%$(SRC)/var/log%g \
	| sed s%_STATICPAGESDIR_%$(SRC)/files%g \
	| sed s%_CONFIGDIR_%$(SRC)/etc/ocsigen%g \
	| sed s%_DATADIR_%$(SRC)/var/lib%g \
	| sed s%_EXTRALIBDIR_%$(SRC)/extensions/ocsipersist-dbm%g \
	| sed s%_UP_%$(SRC)/tmp%g \
	| sed s%_OCSIGENUSER_%%g \
	| sed s%_OCSIGENGROUP_%%g \
	| sed s%_OCSIGENNAME_%$(OCSIGENNAME)%g \
	| sed s%_COMMANDPIPE_%$(SRC)/var/run/ocsigen_command%g \
	| sed s%_MIMEFILE_%$(SRC)/files/mime.types%g \
	| sed s%_MODULEINSTALLDIR_%$(SRC)/extensions%g \
	| sed s%_ELIOMINSTALLDIR_%$(SRC)/eliom%g \
	| sed s%_EXAMPLESINSTALLDIR_%$(SRC)/examples%g \
	| sed s%_METADIR_%$(SRC)/files%g \
	| sed s%_CAMLZIPNAME_%$(CAMLZIPNAME)%g \
	| sed s%files/miniwiki%examples/miniwiki/files%g \
	| sed s%var/lib/miniwiki%examples/miniwiki/wikidata%g \
	| sed s%\<\!--\ \<commandpipe%\<commandpipe%g \
	| sed s%\</commandpipe\>%\</commandpipe\>\ \<\!--%g \
	| sed s%\<\!--\ \<mimefile%\<mimefile%g \
	| sed s%\</mimefile\>%\</mimefile\>\ \<\!--%g \
	| sed s%ocsipersist-dbm.cma%ocsipersist-dbm/ocsipersist-dbm.cma%g \
	| sed s%store\ dir=\"$(SRC)/var/lib\"%store\ dir=\"$(SRC)/var/lib/ocsipersist\"%g \
	> $(OCSIGENNAME).conf.local
	cat $(OCSIGENNAME).conf.local \
	| sed s%[.]cmo%.cmxs%g \
	| sed s%[.]cma%.cmxs%g \
	| sed s%sist-dbm/ocsidbm\"%sist-dbm/ocsidbm.opt\"%g \
	| sed s%sqlite3.cmxs\"/\>%sqlite3.cmxs\"/\>\ \<\!--\ Create\ sqlite3.cmxs\ using:\ ocamlopt\ -shared\ -linkall\ -I\ \<path\ to\ ocaml\'s\ sqlite3\ directory\>\ -o\ sqlite3.cmxs\ \<path\ to\>/libsqlite3_stubs.a\ \<path\ to\>/sqlite3.cmxa\ --\>%g \
	> $(OCSIGENNAME).conf.opt.local

clean:
	-@for i in $(REPS) ; do $(MAKE) -C $$i clean ; done
	-rm -f $(OCSIGENNAME).conf.local $(OCSIGENNAME).conf.opt.local
	-rm -f $(METAS) $(OCSIGENNAME)-*.tar.gz
	-find . -name "*~" -delete

distclean: clean
	-find . -name "*depend" -delete
	-find doc -type f -delete
	-rm -f Makefile.config

depend:
	$(MAKE) -C xmlp4 depend

=== baselib/Makefile ===
include ../Makefile.config

ifeq "$(NATIVECODE)" "YES"
  ifeq "$(NATDYNLINK)" "YES"
  NATIVECODE_RUNTIME_DETECT=Dynlink.is_native
  DYNLINKWRAPPER=dynlink_wrapper.ml
  else
  NATIVECODE_RUNTIME_DETECT=false
  DYNLINKWRAPPER=dynlink_wrapper.mlnonatdynlink
  endif
else
NATIVECODE_RUNTIME_DETECT=false
DYNLINKWRAPPER=dynlink_wrapper.ml
endif

FILES= ocsigen_cache.ml ocsigen_lib_obrowser.ml ocsigen_lib.ml \
       ocsigen_messages.ml ocsigen_config.ml ocsigen_stream.ml \
       ocsigen_commandline.ml ocsigen_loader.ml dynlink_wrapper.ml polytables.ml

CAMLC = $(OCAMLFIND) $(CAMLCNAME) $(DBG) $(LIB)
CAMLOPT = $(OCAMLFIND) $(CAMLOPTNAME) $(DBG) $(LIB)
CAMLDOC = $(OCAMLFIND) ocamldoc $(LIB)
CAMLDEP = $(OCAMLFIND) ocamldep
LIB = -package lwt.unix,netstring,findlib -I +camlp4 $(LIBDIRS)
PP =

OBJS = $(FILES:.ml=.cmo)
OBJSOPT = $(FILES:.ml=.cmx)
CMI = ocsigen_getcommandline.cmi $(FILES:.ml=.cmi)

byte: $(OBJS) $(CMI) parsecommandline.cma donotparsecommandline.cma
#	cp -f $(OBJS) $(CMI) ../lib


# please do not forget CMXS!
CMXA= polytables.cmxa parsecommandline.cmxa \
	donotparsecommandline.cmxa
CMXS=$(CMXA:.cmxa=.cmxs)
DEPOPTBASE=$(OBJSOPT) $(CMI) $(CMXA)
ifeq "$(NATDYNLINK)" "YES"
  DEPOPT=$(DEPOPTBASE) $(CMXS)
else
  DEPOPT=$(DEPOPTBASE)
endif
opt: $(DEPOPT)
#	cp -f $(OBJSOPT) $(OBJSOPT:.cmx=.o) $(CMI) ../lib

parsecommandline.cma: commandline/ocsigen_getcommandline.cmo
	$(CAMLC) -a -o $@  $<

donotparsecommandline.cma: nocommandline/ocsigen_getcommandline.cmo
	$(CAMLC) -a -o $@  $<

parsecommandline.cmxa: commandline/ocsigen_getcommandline.cmx
	$(CAMLOPT) -a -o $@  $<

donotparsecommandline.cmxa: nocommandline/ocsigen_getcommandline.cmx
	$(CAMLOPT) -a -o $@  $<

polytables.cmxa: polytables.cmx
	$(CAMLOPT) -a -o $@  $<

.SUFFIXES:
.SUFFIXES: .ml .mli .cmo .cmi .cmxa .cmx .cmxs

.PHONY: doc depend

dynlink_wrapper.cmx:
	$(CAMLOPT) $(PP) -c -impl $(DYNLINKWRAPPER)

.ml.cmo:
	$(CAMLC) $(PP) -c $<

.mli.cmi:
	$(CAMLC) -c $<

.ml.cmx:
	$(CAMLOPT) $(PP) -c $<

.cmxa.cmxs:
	$(CAMLOPT) -shared -linkall -o $@ $<


ocsigen_config.ml: ocsigen_config.ml.in
	cat ocsigen_config.ml.in \
	| sed s%0000000000000000%`head -n 1 ../VERSION`% \
	| sed s%_WARNING_%"Warning: this file has been generated from ocsigen_config.ml.in - DO NOT MODIFY MANUALLY!"% \
	| sed s%_LOGDIR_%$(LOGDIR)% \
	| sed s%_DATADIR_%$(DATADIR)%g \
	| sed s%_BINDIR_%$(BINDIR)%g \
	| sed s%_EXTRALIBDIR_%$(EXTRALIBDIR)%g \
	| sed s%_STATICPAGESDIR_%$(STATICPAGESDIR)% \
	| sed s%_UP_%$(UPLOADDIR)%g \
	| sed s%_OCSIGENUSER_%$(OCSIGENUSER)%g \
	| sed s%_OCSIGENGROUP_%$(OCSIGENGROUP)%g \
	| sed s%_OCSIGENNAME_%$(OCSIGENNAME)%g \
	| sed s%_COMMANDPIPE_%$(COMMANDPIPE)%g \
	| sed s%_CONFIGDIR_%$(CONFIGDIR)% \
	| sed s%_ISNATIVE_%$(NATIVECODE_RUNTIME_DETECT)%g \
	> ocsigen_config.ml

doc:
	$(CAMLDOC) -d doc -html ocsicache.mli

clean:
	-rm -f *.cm[ioax] *.cmxa *.cmxs *.o *.a *~ *.annot ocsigen_config.ml
	cd commandline; rm -f *.cm[iox]* *.annot *.o
	cd nocommandline; rm -f *.cm[iox]* *.annot *.o

depend: ocsigen_config.ml
	$(CAMLDEP) $(PP) $(LIBDIRS) $(FILES:.ml=.mli) $(FILES) $(CMXS) > .depend

FORCE:

-include .depend

=== eliom/Makefile ===
include ../Makefile.config

# /!\ Simple expanded variable, because of camlzip below
FILES:= error_pages.ml \
	eliom_common_obrowser.ml eliom_common.ml \
	eliommod_sessiongroups.ml eliommod_cookies.ml \
	eliommod_sersess.ml eliommod_datasess.ml eliommod_persess.ml \
	eliommod_gc.ml \
	eliommod_extensions.ml eliommod_services.ml eliommod_naservices.ml \
	eliommod_sessexpl.ml eliommod_sessadmin.ml \
	eliommod_timeouts.ml \
	eliommod_pagegen.ml \
	eliommod.ml eliom_sessions.ml eliom_extensions.ml\
        eliom_parameters_obrowser.ml eliom_parameters.ml \
	eliom_services_obrowser.ml eliom_services.ml \
        eliom_mkforms.ml eliom_mkreg.ml eliom_predefmod.ml \
        eliom_tools_common.ml eliom_tools.ml eliom_extension_template.ml \
	eliom_obrowser.ml
#       ocsigenmod.ml ocsigen.ml ocsigenboxes.ml

ifeq "$(NATDYNLINK)" "YES"
CMXS1=$(OBJSQLITE:.cma=.cmxs)
CMXS2=$(OBJDBM:.cma=.cmxs)
CMXS3=eliom.cmxs $(DUCEMODOPT)
else
CMXS1=$(OBJSQLITE:.cma=.cmxa)
CMXS2=$(OBJDBM:.cma=.cmxa)
CMXS3=eliom.cmxa $(DUCEMODOPT)
endif

ifeq "$(OCAMLDUCE)" "YES"
DUCEFILES= xhtmltypes_duce.ml xhtmlpretty_duce.ml eliom_duce.ml eliom_duce_tools.ml
#DUCEFILES= xhtmltypes_duce.ml ocsigenduce.ml eliom_duce.ml
# rss2.ml ocsigenrss.ml

  ifeq "$(BYTECODE)" "YES"
  DUCEMODBYTE= eliom_duce.cma
#  DUCEMODBYTE=ocsigenduce.cma eliom_duce.cma
# ocsigenrss.cma
  else
  DUCEMODBYTE=
  endif

  ifeq "$(NATDYNLINK)" "YES"
     EDUCECMXS=eliom_duce.cmxs
  else
     EDUCECMXS=eliom_duce.cmxa
  endif

  ifeq "$(NATIVECODE)" "YES"
  DUCEMODOPT= eliom_duce.cmxa $(EDUCECMXS)
#  DUCEMODOPT=ocsigenduce.cmxs eliom_duce.cmxs
# ocsigenrss.cmxs
  else
  DUCEMODOPT=
  endif

OCAMLFIND=$(OCAMLDUCEFIND)
else
DUCEFILES=
DUCEMODBYTE=
DUCEMODOPT=
endif


ifeq "$(NEWOCAMLNET)" "YES"
NETSYS=netsys
NETSYSCMA=netsys.cma
NETSYSCMXA=netsys.cmxa
else
NETSYS=
NETSYSCMA=
NETSYSCMXA=
endif

# LIB=$(LIBDIRS)

LIB = -thread -package lwt.unix,netstring,cryptokit $(LIBDIRS)
CAMLC = $(OCAMLFIND) $(CAMLCNAME2) $(DBG) $(LIB)
CAMLOPT = $(OCAMLFIND) $(CAMLOPTNAME) $(DBG) $(LIB)
CAMLDOC = $(OCAMLFIND) ocamldoc $(LIB)
CAMLDEP = $(OCAMLFIND) ocamldep $(LIBDIRS)
PP = 
PP2 = 
# -pp "$(CAMLP4O) ../lib/xhtmlsyntax.cma -- -loc loc"


OBJS = $(OBJSQLITE) $(FILES:.ml=.cmo) $(DUCEFILES:.ml=.cmo) $(OBJDBM)

OBJSOPT = $(CMXS1) $(FILES:.ml=.cmx) $(DUCEFILES:.ml=.cmx) $(CMXS2)


byte: $(FILESSQLITE:.ml=.cmo) $(OBJS) eliom.cma $(DUCEMODBYTE) obrowser pa_eliom_obrowser.cmo

opt: $(FILESSQLITE:.ml=.cmx) $(OBJSOPT) eliom.cmxa $(CMXS3) pa_eliom_obrowser.cmo


.SUFFIXES:
.SUFFIXES: .ml .mli .cmo .cmi .cmx

.PHONY: doc depend obrowser

obrowser:
	$(MAKE) -C obrowser all

eliom_sessions.cmx: eliom_sessions.ml
#	-rm ../extensions/ocsipersist.cmx
	$(CAMLOPT) $(PP) -c $<
#	-touch ../extensions/ocsipersist.cmx
# we remove ocsipersist.cmx, 
# otherwise eliomsessiondata.cmx will will compiled against
# that precise version of ocsipersist.cmx

eliommod.cmx: eliommod.ml
#	-rm ../extensions/ocsipersist.cmx
	$(CAMLOPT) $(PP) -c $<
#	-touch ../extensions/ocsipersist.cmx
# idem

eliom.cma: $(FILES:.ml=.cmo)
	$(CAMLC) -a -o eliom.cma $^
	cd ../extensions ; ln -f -s ../eliom/eliom.cma

eliom.cmxa: $(FILES:.ml=.cmx)
	$(CAMLOPT) -a -o eliom.cmxa -linkall $^
	cd ../extensions ; ln -f -s ../eliom/eliom.cmxa

eliom.cmxs: $(FILES:.ml=.cmx)
	$(CAMLOPT) -shared -linkall -o eliom.cmxs $^
	cd ../extensions ; ln -f -s ../eliom/eliom.cmxs

ocsigenmod.cma: ocsigenmod.cmo ocsigen.cmo ocsigenboxes.cmo
	$(CAMLC) -a -o ocsigenmod.cma ocsigenmod.cmo ocsigen.cmo \
	ocsigenboxes.cmo

ocsigenmod.cmxs: ocsigenmod.cmx ocsigen.cmx ocsigenboxes.cmx
	$(CAMLOPT) -shared -linkall -o ocsigenmod.cmxs ocsigenmod.cmx \
	ocsigen.cmx ocsigenboxes.cmx

ocsigenmod.cmxa: ocsigenmod.cmx ocsigen.cmx ocsigenboxes.cmx
	$(CAMLOPT) -a -linkall -o ocsigenmod.cmxa ocsigenmod.cmx \
	ocsigen.cmx ocsigenboxes.cmx

ocsigenduce.cma: xhtmltypes_duce.cmo xhtmlpretty_duce.cmo ocsigenduce.cmo
	$(CAMLC) -a -o ocsigenduce.cma xhtmltypes_duce.cmo xhtmlpretty_duce.cmo ocsigenduce.cmo 

ocsigenduce.cmxs: xhtmltypes_duce.cmx xhtmlpretty_duce.cmx ocsigenduce.cmx
	$(CAMLOPT) -shared -linkall -o ocsigenduce.cmxs xhtmltypes_duce.cmx xhtmlpretty_duce.cmx ocsigenduce.cmx 

ocsigenduce.cmxa: xhtmltypes_duce.cmx xhtmlpretty_duce.cmx ocsigenduce.cmx
	$(CAMLOPT) -a -linkall -o ocsigenduce.cmxa xhtmltypes_duce.cmx xhtmlpretty_duce.cmx ocsigenduce.cmx 

eliom_duce.cma: xhtmltypes_duce.cmo xhtmlpretty_duce.cmo eliom_duce.cmo
	$(CAMLC) -a -o eliom_duce.cma xhtmltypes_duce.cmo xhtmlpretty_duce.cmo eliom_duce.cmo eliom_duce_tools.cmo
	cd ../extensions ; ln -f -s ../eliom/eliom_duce.cma

eliom_duce.cmxs: xhtmltypes_duce.cmx xhtmlpretty_duce.cmx eliom_duce.cmx
	$(CAMLOPT) -shared -linkall -o eliom_duce.cmxs xhtmltypes_duce.cmx xhtmlpretty_duce.cmx eliom_duce.cmx eliom_duce_tools.cmx
	cd ../extensions ; ln -f -s ../eliom/eliom_duce.cmxs

eliom_duce.cmxa: xhtmltypes_duce.cmx xhtmlpretty_duce.cmx eliom_duce.cmx
	$(CAMLOPT) -a -linkall -o eliom_duce.cmxa xhtmltypes_duce.cmx xhtmlpretty_duce.cmx eliom_duce.cmx eliom_duce_tools.cmx
	cd ../extensions ; ln -f -s ../eliom/eliom_duce.cmxa

ocsigenrss.cma: rss2.cmo ocsigenrss.cmo
	$(CAMLC) -a -o ocsigenrss.cma $^

ocsigenrss.cmxs: rss2.cmx ocsigenrss.cmx
	$(CAMLOPT) -shared -linkall -o ocsigenrss.cmxs $^

ocsigenrss.cmxa: rss2.cmx ocsigenrss.cmx
	$(CAMLOPT) -a -shared -linkall -o ocsigenrss.cmxa $^

pa_eliom_obrowser.cmo: pa_eliom_obrowser.ml
	ocamlc -c -I +camlp4 -I +camlp4/Camlp4Printers \
	  -I +camlp4/Camlp4Parsers -pp camlp4of pa_eliom_obrowser.ml

# There is a bug with ocamlduce when -g is supplied
bugdbg:
	$(MAKE) DEBUG="NO" eliom_duce.cmo


.ml.cmo:
	$(CAMLC) $(PP) -c $<

.mli.cmi:
	$(CAMLC) -c $<

.ml.cmx:
	$(CAMLOPT) $(PP) -c $<


#doc:
#	$(CAMLDOC) -d doc -html eliom.mli ocsigen.mli ocsigen_extensions.mli

.PHONY: clean
clean: 
	-rm -f *.cm[aiox] *.cmxa *.cmxs *.o *.a *~ doc/*  *.annot
	$(MAKE) -C obrowser clean

depend:
	$(CAMLDEP) $(PP2) $(FILESSQLITE:.ml=.mli) $(FILESSQLITE) $(FILES:.ml=.mli) $(FILES) $(DUCEFILES:.ml=.mli) $(DUCEFILES) $(OBROWSERFILES) > .depend
	sed -i.bak s%../extensions/ocsipersist.cmx%% .depend

FORCE:

-include .depend

=== http/Makefile ===
include ../Makefile.config


CAMLC    = $(OCAMLFIND) $(CAMLCNAME2) $(DBG)
CAMLDOC  = $(OCAMLFIND) ocamldoc
FLAGS    =
CAMLCOPT = $(OCAMLFIND) $(CAMLOPTNAME) $(DBG)
CAMLDEP  = $(OCAMLFIND) ocamldep $(LIBDIRS)
NAME 	 = test_pp
LIB= -package netstring,ssl,lwt $(LIBDIRS) -I +camlp4
PP =
# -pp "camlp4o ../lib/xhtmlsyntax.cma -- -loc loc" 
ALL_CMO = multipart.cmo http_headers.cmo		\
           ocsigen_http_frame.cmo http_parser.cmo http_lexer.cmo	\
           framepp.cmo ocsigen_http_com.cmo ocsigen_charset_mime.cmo	\
           ocsigen_senders.cmo ocsigen_headers.cmo ocsigen_range.cmo
	 #test_pp.cmo

ALL_CMX  = $(ALL_CMO:.cmo=.cmx)

.PHONY: depend

byte: $(ALL_CMO)
#	$(CAMLC) $(LIB) -o $(NAME) unix.cma lwt.cma netstring.cma xhtml.cma $(ALL_CMO)
#	cp *.cmi *.cmo  ../lib

opt: $(ALL_CMX)
#	cp *.cmi *.cmx *.o ../lib


doc: 
	$(CAMLDOC) $(PP) $(LIB) -html -d documentation *.ml *.mli

clean:
	-rm -f $(NAME) $(OPTNAME) *.cm[oiax] *.cmxa *.cmxs *.o *.annot \
	http_parser.ml http_parser.mli http_lexer.ml documentation/*	

viclean: clean
	-rm *~

depend:
	$(CAMLDEP) $(PP) $(LIBDIRS) *.ml *.mli *.mll *.mly > .depend

http_parser.cmo:http_parser.ml http_parser.mli http_parser.cmi
http_parser.cmx:http_parser.ml http_parser.mli http_parser.cmi

http_lexer.cmo:http_lexer.ml http_lexer.cmi
http_lexer.cmx:http_lexer.ml http_lexer.cmi

http_lexer.ml: http_lexer.mll

http_parser.ml: http_parser.mly


# generic rules :
#################

.SUFFIXES: .mll .mly .mli .ml .cmi .cmo .cmx

.mll.mli:
	$(CAMLLEX) $<

.mll.ml:
	$(CAMLLEX) $<

.mly.ml:
	$(CAMLYACC) $<

.mly.mli:
	$(CAMLYACC) $<

.mli.cmi:
	$(CAMLC) -c $(FLAGS) $(LIB) $<

.ml.cmi:
	$(CAMLC) -c $(FLAGS) $(LIB) $<

.ml.cmo:
#	-rm $(LIBDIR)/$(<:.ml=.cmo)
#	-rm $(LIBDIR)/$(<:.ml=.cmi)
	$(CAMLC) $(PP) -c $(FLAGS) $(LIB) $<

.ml.o:
	$(CAMLCOPT) -c $(FLAGS) $(LIB) $<

.ml.cmx:
	$(CAMLCOPT) $(PP) -c $(PROFILE) $(FLAGS) $(LIB) $<

-include .depend

=== xmlp4/Makefile ===
include ../Makefile.config

FILES = xhtmlpretty.ml xhtmlcompact.ml \
	xhtmlpretty_streams.ml xhtmlcompact_streams.ml

CAMLC = $(OCAMLFIND) $(CAMLCNAME) $(DBG) $(LIB) -package camlp4
CAMLOPT = $(OCAMLFIND) $(CAMLOPTNAME) $(DBG) $(LIB) -package camlp4
CAMLDEP = $(OCAMLFIND) ocamldep $(LIB) -package camlp4
LIB = $(LIBDIRS)
# PP = -syntax camlp4o -ppopt "pa_macro.cmo"
# PPLEXER = -syntax camlp4of -ppopt "-loc loc"

OBJS = $(FILES:.ml=.cmo)
OBJSOPT = $(FILES:.ml=.cmx)


byte: bytedep $(OBJS) xhtmlpretty.cma
xmlp4pre.byte: bytedep
xmlp4pre.opt: optdep
opt: optdep $(OBJSOPT) xhtmlpretty.cmxa

bytedep:
	$(MAKE) -C newocaml byte

optdep:
	$(MAKE) -C newocaml opt


xhtmlpretty.cma: xhtmlpretty.cmo xhtmlcompact.cmo
	$(CAMLC) -a -o xhtmlpretty.cma xhtmlpretty.cmo xhtmlcompact.cmo

xhtmlpretty.cmxa: xhtmlpretty.cmx xhtmlcompact.cmx
	$(CAMLOPT) -a -o xhtmlpretty.cmxa xhtmlpretty.cmx xhtmlcompact.cmx

# Common rules
.SUFFIXES: .ml .mli .cmo .cmi .cmx

.ml.cmo:
	$(CAMLC) $(PP) -c $<
.mli.cmi:
	$(CAMLC) $(PP) -c $<
.ml.cmx:
	$(CAMLOPT) $(PP) -c $<



clean:
#	touch oldocaml/.depend
#	touch newocaml/.depend
	-rm -f *.cm[ioax] *.cmxa *.cmxs *.o *.a *~ *.annot
	-$(MAKE) -C newocaml clean

depend:
#	touch oldocaml/.depend
#	touch newocaml/.depend
	$(CAMLDEP) -I ohl-xhtml $(PP) $(FILES) > .depend
	$(MAKE) -C newocaml depend


-include .depend

=== eliom/obrowser/Makefile ===

CMA:= eliom_obrowser_client.cma
OCAMLBUILD:= ocamlbuild -classic-display

all: $(CMA)

$(CMA): mls
	$(OCAMLBUILD) $(CMA)

mls: eliom_parameters.ml eliom_services.ml eliom_common.ml eliom_mkforms.ml ocsigen_lib_obrowser.ml polytables.ml

eliom_parameters.ml: ../eliom_parameters_obrowser.ml
	cp -f ../eliom_parameters_obrowser.ml eliom_parameters.ml

eliom_services.ml: ../eliom_services_obrowser.ml
	cp -f ../eliom_services_obrowser.ml eliom_services.ml

eliom_common.ml: ../eliom_common_obrowser.ml
	cp -f ../eliom_common_obrowser.ml eliom_common.ml

eliom_mkforms.ml: ../eliom_mkforms.ml
	cp -f ../eliom_mkforms.ml .

ocsigen_lib_obrowser.ml: ../../baselib/ocsigen_lib_obrowser.ml .
	cp -f ../../baselib/ocsigen_lib_obrowser.ml .

polytables.ml: ../../baselib/polytables.ml
	cp -f ../../baselib/polytables.ml .

#_build/pa_eliom_obrowser.cmo:
#	$(OCAMLBUILD) $@


#eliom_obrowser_client.cmo:
#	$(CAMLC) -package obrowser $(PP) -c eliom_obrowser_client.ml
#
#lwt_obrowser.cmo:
#	ocamlfind ocamlc -package obrowser,lwt.syntax -syntax camlp4o -c lwt_obrowser.ml
#
#eliom_obrowser_client.cma: lwt_obrowser.cmo eliom_obrowser_client.cmo
#	$(CAMLC) -a -o $@ $^

clean:
	rm -rf _build

=== examples/miniwiki/Makefile ===
include ../../Makefile.config

FILES=$(wildcard *.ml)

LIB = -package lwt.unix,pcre $(LIBDIRS2)
CAMLC = $(OCAMLFIND) $(CAMLCNAME) $(DBG) $(LIB)
CAMLOPT = $(OCAMLFIND) $(CAMLOPTNAME) $(DBG) $(LIB)
CAMLDEP = $(OCAMLFIND) ocamldep

ifeq "$(NATDYNLINK)" "YES"
CMXS=$(FILES:.ml=.cmxs)
CMXSCMD=cp $(OBJSOPT) ..
else
CMXS=
CMXSCMD=
endif


OBJS=$(FILES:.ml=.cmo)
OBJSOPT=$(CMXS)

byte: $(OBJS)
	cp $(OBJS) ..

opt: $(OBJSOPT)
	$(CMXSCMD)


.SUFFIXES:
.SUFFIXES: .ml .mli .cmo .cmi .cmx .cmxs

.PHONY: doc

.ml.cmo:
	$(CAMLC) -c $<

.mli.cmi:
	$(CAMLC) -c $<

.ml.cmx:
	$(CAMLOPT) -c $<

.cmx.cmxs:
	$(CAMLOPT) -shared -linkall -o $@ $<

clean:
	-rm -f *.cm[ioxa] *.cmxa *.cmxs *.o *~ $(NAME)

depend:
	$(CAMLDEP) $(PP) $(LIB) $(FILES:.ml=.mli) $(FILES) > .depend

-include .depend

=== extensions/ocsipersist-dbm/Makefile ===
include ../../Makefile.config

FILES= ocsipersist.ml
OBJDBM= ocsipersist-dbm.cma


ifeq "$(NATDYNLINK)" "YES"
CMXS=$(OBJDBM:.cma=.cmxs)
else
CMXS=
endif


LIB = -thread -package lwt.unix,netstring,dbm $(LIBDIRS2)
CAMLC = $(OCAMLFIND) $(CAMLCNAME) $(DBG) $(LIB)
CAMLOPT = $(OCAMLFIND) $(CAMLOPTNAME) $(DBG) $(LIB)
CAMLDOC = $(OCAMLFIND) ocamldoc $(LIB)
CAMLDEP = $(OCAMLFIND) ocamldep $(LIBDIRS2)
PP = 
PP2 = 
# -pp "$(CAMLP4O) ../lib/xhtmlsyntax.cma -- -loc loc"


OBJS = $(FILES:.ml=.cmo) ocsidbm $(OBJDBM)

OBJSOPT = $(FILES:.ml=.cmx) ocsidbm.opt $(CMXS) $(OBJDBM:.cma=.cmxa)


byte: ocsipersist.mli $(OBJS)

opt: ocsipersist.mli $(OBJSOPT)
	[ -f ../ocsipersist.cmx ] || \
	cp ocsipersist.cmx ..
	[ -f ../ocsipersist.o ] || \
	cp ocsipersist.o ..


.SUFFIXES:
.SUFFIXES: .ml .mli .cmo .cmi .cmx

.PHONY: doc depend

ocsipersist-dbm.cma: ocsipersist.cmo
	$(CAMLC) -a -o ocsipersist-dbm.cma ocsipersist.cmo
	cp -f ocsipersist-dbm.cma ..

ocsipersist-dbm.cmxa: ocsipersist.cmx
	$(CAMLOPT) -a -o ocsipersist-dbm.cmxa ocsipersist.cmx
	cp -f ocsipersist-dbm.cmxa ..

ocsipersist-dbm.cmxs: ocsipersist.cmx
	$(CAMLOPT) -shared -linkall -o ocsipersist-dbm.cmxs ocsipersist.cmx
	cp -f ocsipersist-dbm.cmxs ..

ocsidbm: ocsidbm.cmo
	$(CAMLC) -linkpkg -o $@ $<

ocsidbm.opt: ocsidbm.cmx
	$(CAMLOPT) -linkpkg -o $@ $<

ocsipersist.mli:
	cp -f ../ocsipersist.mli .

.ml.cmo:
	$(CAMLC) $(PP) -c $<

.mli.cmi:
	$(CAMLC) -c $<
.ml.cmx:
	$(CAMLOPT) $(PP) -c $<

#doc:
#	$(CAMLDOC) -d doc -html eliom.mli ocsigen.mli ocsigen_extensions.mli

.PHONY: clean
clean:
	-rm -f *.cm[aiox] *.cmxa *.cmxs *.cmx *.o *.a *~ doc/*  *.annot ocsidbm ocsidbm.opt ocsipersist.mli

depend: ocsipersist.mli
	$(CAMLDEP) $(PP2) $(FILES:.ml=.mli) $(FILES) > .depend


FORCE:

-include .depend

=== xmlp4/newocaml/Makefile ===
include ../../Makefile.config


FILESR = xmllexer.ml camllexer.ml
FILES = basicTypes.ml xhtmltypes.ml simplexmlparser.ml xhtmlsyntax.ml xhtmlparser.ml 

CAMLC = $(OCAMLFIND) $(CAMLCNAME) $(DBG) $(LIB) 
CAMLOPT = $(OCAMLFIND) $(CAMLOPTNAME) $(DBG) $(LIB) 
CAMLDEP = $(OCAMLFIND) ocamldep
LIB = -I `$(CAMLP4) -where` -I +camlp4/Camlp4Parsers $(LIBDIRS2)
PP = -pp "camlp4rf -- -loc loc"
PPLEXER = -pp "camlp4of -- -loc loc"

OBJS = $(FILESR:.ml=.cmo) $(FILES:.ml=.cmo)
OBJSOPT = $(FILESR:.ml=.cmx) $(FILES:.ml=.cmx)

CMA = xhtmlsyntax.cma
CMXA = xhtmlsyntax.cmxa

byte: ohl-xhtml-byte $(CMA) $(OBJS)
	camlp4r simplexmlparser.mli -printer o > pp/simplexmlparser.mli
	camlp4r xhtmltypes.ml -printer o > pp/xhtmltypes.ml
	ln -sf newocaml/xhtmltypes.cmi newocaml/xhtmltypes.cmo newocaml/basicTypes.cmi newocaml/basicTypes.cmo newocaml/simplexmlparser.cmi newocaml/simplexmlparser.cmo newocaml/xmllexer.cmi newocaml/xmllexer.cmo newocaml/camllexer.cmi newocaml/camllexer.cmo newocaml/xhtmlsyntax.cma ..

opt: ohl-xhtml-opt $(CMXA) $(OBJSOPT)
	ln -sf newocaml/xhtmltypes.cmi newocaml/xhtmltypes.cmx newocaml/xhtmltypes.o newocaml/basicTypes.cmi newocaml/basicTypes.cmx newocaml/basicTypes.o newocaml/simplexmlparser.cmi newocaml/simplexmlparser.cmx newocaml/simplexmlparser.o newocaml/xmllexer.cmi newocaml/xmllexer.cmx newocaml/xmllexer.o newocaml/camllexer.cmi newocaml/camllexer.cmx newocaml/camllexer.o newocaml/xhtmlsyntax.cmxa newocaml/xhtmlsyntax.a ..

.PHONY: depend ohl-xhtml-byte ohl-xhtml-opt

ohl-xhtml-byte:
	-rm -f ../xhtmltypes.cmi ../basicTypes.cmi ../simplexmlparser.cmi ../xmllexer.cmi
	$(MAKE) -C ../ohl-xhtml byte
	cp ../ohl-xhtml/xhtml.cma ../ohl-xhtml/xHTML.cmi ../ohl-xhtml/xML.cmi ..

ohl-xhtml-opt:
	-rm -f ../xhtmltypes.cmi ../basicTypes.cmi ../simplexmlparser.cmi ../xmllexer.cmi
	$(MAKE) -C ../ohl-xhtml opt
	cp ../ohl-xhtml/xhtml.cmxa ../ohl-xhtml/xhtml.a ../ohl-xhtml/xHTML.cmi ../ohl-xhtml/xML.cmi ..

$(CMA): basicTypes.cmo xmllexer.cmo camllexer.cmo xhtmlparser.cmo xhtmlsyntax.cmo
	$(CAMLC) -a -o $(CMA) xmllexer.cmo camllexer.cmo xhtmlparser.cmo xhtmlsyntax.cmo

$(CMXA): basicTypes.cmx xmllexer.cmx camllexer.cmx xhtmlparser.cmx xhtmlsyntax.cmx
	$(CAMLOPT) -a -o $(CMXA) xmllexer.cmx camllexer.cmx xhtmlparser.cmx xhtmlsyntax.cmx


xmllexer.cmo: xmllexer.ml
	$(CAMLC) $(PPLEXER) -c $<

xmllexer.cmx: xmllexer.ml
	$(CAMLOPT) $(PPLEXER) -c $<

xmllexer.ml: xmllexer.mll
	$(CAMLLEX) $<


camllexer.cmo: camllexer.ml
	$(CAMLC) $(PPLEXER) -c $<

camllexer.cmx: camllexer.ml
	$(CAMLOPT) $(PPLEXER) -c $<

camllexer.ml: camllexer.mll
	$(CAMLLEX) $<


# Common rules
.SUFFIXES: .ml .mli .cmo .cmi .cmx

.ml.cmo:
	$(CAMLC) $(PP) -c $<
.mli.cmi:
	$(CAMLC) $(PP) -c $<
.ml.cmx:
	$(CAMLOPT) $(PP) -c $<



# Clean up
clean:
	-rm -f xmllexer.ml camllexer.ml *.cm[ioax] *.cmxa *~ *.annot *.a *.o
	$(MAKE) -C ../ohl-xhtml clean


# Dependencies
depend: *.mli *.ml
	-rm -f xmllexer.ml camllexer.ml
	$(CAMLDEP) $(PP) $(LIBDIRS2) *.mli *.ml > .depend

FORCE:

-include .depend

=== xmlp4/ohl-xhtml/Makefile ===
# $Id: Makefile,v 1.18 2005/06/20 17:57:58 ohl Exp $
#
# Copyright (C) 2004 by Thorsten Ohl <ohl@physik.uni-wuerzburg.de>
#
# XHTML is free software; you can redistribute it and/or modify it
# under the terms of the GNU General Public License as published by 
# the Free Software Foundation; either version 2, or (at your option)
# any later version.
#
# XHTML is distributed in the hope that it will be useful, but
# WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the 
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
#
########################################################################

include ../../Makefile.config

SED = sed
RM = rm
MV = mv
DIFF = diff


LIB = -package netstring
OCAMLC = $(OCAMLFIND) $(CAMLCNAME2) $(DBG) $(LIB)
OCAMLOPT = $(OCAMLFIND) $(CAMLOPTNAME) $(DBG) $(LIB)

DOLLAR = $$

SUBDIRS = examples experimental private

SRC_ML = xML.ml xHTML.ml
SRC_MLI = $(SRC_ML:.ml=.mli)

DISTFILES = README ChangeLog COPYING Makefile $(SRC_MLI) $(SRC_ML) \
	examples/Makefile examples/www_ls.ml examples/homepage.ml \
	experimental/zipper.mli experimental/zipper.ml \
	experimental/document.mli experimental/document.ml

########################################################################

all: bin opt

byte: xhtml.cma
bin: xhtml.cma
opt: xhtml.cmxa

xhtml.cmxa: xML.cmx xHTML.cmx
	$(OCAMLOPT) -a -o $@ $^

xhtml.cma: xML.cmo xHTML.cmo
	$(OCAMLC) -a -g -o $@ $^

%.cmx: %.ml
	$(OCAMLOPT) -c -o $@ $<

%.cmo: %.ml
	$(OCAMLC) -g -c -o $@ $<

%.cmi: %.mli
	$(OCAMLC) -c -o $@ $<

clean:
	-rm -f *.o *.cm[iox] *.cma *.cmxa *.a *~ xHTML.mli
	-@for d in $(SUBDIRS); do test -d $$d && $(MAKE) -C $$d clean; done

########################################################################

doc: doc/index.html

doc/index.html: xML.mli xHTML.mli
	ocamldoc -html -d doc $^

xHTML.mli: xHTML.ml
	@$(SED) -n '/BEGIN INTERFACE/,/END INTERFACE/p' $< \
	  | $(SED) -e '/BEGIN INTERFACE/d' -e '/END INTERFACE/d' > $@.new
	@if [ -e $@ ] && $(DIFF) -q -I'\$(DOLLAR)Id: ' $@.new $@; then $(RM) $@.new; else $(MV) $@.new $@; fi

########################################################################

PUBLIC_HTML = $(HOME)/public_html/xhtml

VERSION = 20050620

SNAP = xhtml-$(VERSION).tar.gz

snap: $(SNAP)

$(SNAP): $(DISTFILES)
	tar cf - $^ | gzip -9 >$@

export: examples/homepage $(SNAP)
	cp $(SNAP) $(PUBLIC_HTML)
	tar xzf	$(SNAP) -C $(PUBLIC_HTML)
	examples/homepage $(SNAP) >$(PUBLIC_HTML)/index.html

examples/homepage: all
	$(MAKE) -C examples homepage

########################################################################

xHTML.cmo: xML.cmi xHTML.cmi 
xHTML.cmx: xML.cmx xHTML.cmi 
xHTML_sample.cmo: xHTML.cmi 
xHTML_sample.cmx: xHTML.cmx 
xML.cmo: xML.cmi 
xML.cmx: xML.cmi 

########################################################################

=== debian/changelog ===
ocsigen (1.3.4-2) unstable; urgency=low

  * Fix wrong decoding of + in URL paths (cherry-picked from upstream)

 -- Stéphane Glondu <glondu@debian.org>  Tue, 12 Jul 2011 20:38:51 +0200

ocsigen (1.3.4-1) unstable; urgency=low

  * New upstream release
  * Touch .cmi files after installing the .mli files (Closes: #587300)
  * Bump Standards-Version to 3.9.2 (no changes)

 -- Nicolas Dandrimont <nicolas.dandrimont@crans.org>  Sun, 29 May 2011 13:54:41 +0200

ocsigen (1.3.3-3) unstable; urgency=low

  * Do not try to install native objects on non-natdynlink architectures

 -- Stéphane Glondu <glondu@debian.org>  Fri, 22 Apr 2011 23:47:16 +0200

ocsigen (1.3.3-2) unstable; urgency=low

  * Add missing dependencies to ocsigen: libocsigen-xhtml-ocaml-dev and
    liblwt-ssl-ocaml-dev (Closes: #613372)
  * Do not compile native code version if there is no natdynlink
  * Bump debhelper compat level to 8
  * Bump Standards-Version to 3.9.1

 -- Stéphane Glondu <glondu@debian.org>  Tue, 15 Feb 2011 19:01:11 +0100

=== debian/control ===
Source: ocsigen
Section: ocaml
Priority: optional
Maintainer: Debian OCaml Maintainers <debian-ocaml-maint@lists.debian.org>
Uploaders:
 Stéphane Glondu <glondu@debian.org>,
 Samuel Mimram <smimram@debian.org>,
 Nicolas Dandrimont <nicolas.dandrimont@crans.org>
Build-Depends:
 debhelper (>= 8),
 ocaml-nox (>= 3.11.1-3~),
 camlp4-extra,
 ocaml-findlib (>= 1.2.5),
 liblwt-ssl-ocaml-dev (>= 2.1.1),
 libocamlnet-ocaml-dev (>= 2.2.9-7~),
 libpcre-ocaml-dev (>= 6.0.1-2~),
 libssl-ocaml-dev (>= 0.4.3-3~),
 libgdbm-dev,
 libsqlite3-ocaml-dev (>= 1.5.6-3~),
 libzip-ocaml-dev (>= 1.04-6~),
 libcryptokit-ocaml-dev (>= 1.3-14~),
 libobrowser-ocaml-dev,
 ocamlduce (>= 3.11.1.0-2~),
 dh-ocaml (>= 0.9.5~)
Standards-Version: 3.9.2
Homepage: http://www.ocsigen.org/
Vcs-Browser: http://git.debian.org/?p=pkg-ocaml-maint/packages/ocsigen.git
Vcs-Git: git://git.debian.org/git/pkg-ocaml-maint/packages/ocsigen.git

Package: ocsigen
Section: httpd
Architecture: any
Depends: adduser, psmisc, procps,
 libocsigen-xhtml-ocaml-dev,
 liblwt-ssl-ocaml-dev,
 ${ocaml:Depends},
 ${shlibs:Depends},
 ${misc:Depends}
Provides: httpd, httpd-cgi
Suggests: ocsigen-dev
Breaks: nurpawiki (<< 1.2.3-4~)
Description: web server and programming framework in OCaml
 Ocsigen is a Web server and a programming framework providing a new
 way to create dynamic Web sites. Its goal is to offer an alternative
 to Apache/PHP, based on cutting-edge technologies coming from
 research in programming languages. It has most of the features you
 expect from a Web server (static pages, CGI scripts, etc.) and also
 an innovative module, called Eliom, for generating dynamic Web
 pages. With Eliom, you program in a concise and modular way, with a
 strong type system which helps you to produce valid xhtml. The server
 handles sessions, URLs, and page parameters automatically.
 .
 This package contains the web server itself and shared files.

Package: libocsigen-ocaml-doc
Section: doc
Architecture: all
Depends: ${misc:Depends}
Suggests: ocsigen-dev
Provides: ocsigen-doc
Replaces: ocsigen-doc (<< 1.2.2)
Breaks: ocsigen-doc (<< 1.2.2)
Description: developer's documentation for Ocsigen
 Ocsigen is a Web server and a programming framework providing a new
 way to create dynamic Web sites.
 .
 This package contains the documentation of all Ocsigen's modules.
 This is developer's documentation, generated by ocamldoc. The
 documentation for the server itself is available online.

Package: ocsigen-dev
Architecture: all
Depends:
 ocsigen (>= ${binary:Version}),
 libocsigen-ocaml-doc (>= ${binary:Version}),
 libocsigen-ocaml-dev (>= ${binary:Version}),
 ocaml-findlib,
 ${misc:Depends}
Description: development metapackage for Ocsigen
 Ocsigen is a Web server and a programming framework providing a new
 way to create dynamic Web sites. Its goal is to offer an alternative
 to Apache/PHP, based on cutting-edge technologies coming from
 research in programming languages. It has most of the features you
 expect from a Web server (static pages, CGI scripts, etc.) and also
 an innovative module, called Eliom, for generating dynamic Web
 pages. With Eliom, you program in a concise and modular way, with a
 strong type system which helps you to produce valid xhtml. The server
 handles sessions, URLs, and page parameters automatically.
 .
 This metapackage brings everything you need to develop Ocsigen
 extensions and Eliom modules: the development librairies, the server
 itself and documentation.

Package: libocsigen-ocaml
Architecture: any
Depends:
 ${ocaml:Depends},
 ${shlibs:Depends},
 ${misc:Depends}
Provides: ${ocaml:Provides}
Replaces:
 ocsigen (<< 1.2.2),
 ocsigen-dev (<< 1.2.2),
 libocsigen-ocaml-dev (<< 1.3.3)
Breaks:
 ocsigen (<< 1.2.2),
 ocsigen-dev (<< 1.2.2),
 libocsigen-ocaml-dev (<< 1.3.3),
 nurpawiki (<< 1.2.3-4~)
Description: runtime librairies for Ocsigen
 Ocsigen is a Web server and a programming framework providing a new
 way to create dynamic Web sites.
 .
 This package contains runtime librairies for Ocsigen.

Package: libocsigen-ocaml-dev
Architecture: any
Depends:
 ocaml-findlib,
 libgdbm-dev,
 ${ocaml:Depends},
 ${shlibs:Depends},
 ${misc:Depends}
Provides: ${ocaml:Provides}
Recommends: ocsigen-doc
Replaces: ocsigen (<< 1.2.2), ocsigen-dev (<< 1.2.2)
Breaks:
 ocsigen (<< 1.2.2),
 ocsigen-dev (<< 1.2.2),
 nurpawiki (<< 1.2.3-4~)
Description: development librairies for Ocsigen
 Ocsigen is a Web server and a programming framework providing a new
 way to create dynamic Web sites. Its goal is to offer an alternative
 to Apache/PHP, based on cutting-edge technologies coming from
 research in programming languages. It has most of the features you
 expect from a Web server (static pages, CGI scripts, etc.) and also
 an innovative module, called Eliom, for generating dynamic Web
 pages. With Eliom, you program in a concise and modular way, with a
 strong type system which helps you to produce valid xhtml. The server
 handles sessions, URLs, and page parameters automatically.
 .
 This package contains development files for compiling Ocsigen
 extensions and Eliom modules.

Package: libocsigen-xhtml-ocaml-dev
Architecture: any
Depends:
 ${ocaml:Depends},
 ${shlibs:Depends},
 ${misc:Depends}
Provides: ${ocaml:Provides}
Recommends: ocaml-findlib, libocsigen-ocaml-doc
Replaces: libocsigen-ocaml-dev (<< 1.3.0-3~)
Breaks: libocsigen-ocaml-dev (<< 1.3.0-3~)
Description: Ocsigen XHTML generation library
 This package provides the XHTML generation library of Ocsigen, to
 generate statically typed XHTML pages. Typing is achieved with
 polymorphic variants. This library can be used independently of
 Ocsigen. This package contains development files needed to use this
 library alone.

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

include /usr/share/ocaml/ocamlvars.mk

DESTDIR := $(CURDIR)/debian/tmp
export OCAMLOBJINFO := ocamlduceobjinfo

ifeq ($(OCAML_NATDYNLINK),yes)
  OPT_CONFFLAGS := --enable-nativecode
else
  OPT_CONFFLAGS := --disable-nativecode
endif

INSTALL_TARGET := $(if $(findstring libocsigen-ocaml-doc,$(shell dh_listpackages)),install,installnodoc)

%:
	dh $@ --with ocaml


.PHONY: override_dh_auto_configure
override_dh_auto_configure:
	chmod +x configure
	./configure \
	    --temproot $(DESTDIR) \
	    --prefix /usr \
	    --bindir /usr/bin \
	    --libdir $(OCAML_STDLIB_DIR) \
	    --mandir /usr/share/man/man1 \
	    --docdir /usr/share/doc \
	    --staticpagesdir /usr/share \
	    --ocsigen-user ocsigen \
	    --ocsigen-group ocsigen \
	    --stubdir $(OCAML_DLL_DIR) \
	    $(OPT_CONFFLAGS) \
	    --enable-ocamlduce
	cp -a examples debian
# Remove irrelevant files (incl. those installed in /usr/share or /var/lib)
	mv debian/examples/miniwiki/files/miniwiki.conf debian/examples/miniwiki
	rm -Rf \
	  debian/examples/miniwiki/wikidata \
	  debian/examples/miniwiki/files \
	  debian/examples/Makefile


.PHONY: override_dh_auto_install
override_dh_auto_install:
	$(MAKE) $(INSTALL_TARGET) CHOWN=true STD_METAS_DIR=$(OCAML_STDLIB_DIR)/METAS

# For each installed .cmi file, install the corresponding .mli file next to it
	find $(DESTDIR) -name '*.cmi' -printf '%h %f\n' | \
	  while read d f; do \
	    find . -name $${f%.cmi}.mli -exec cp '{}' $$d ';' -quit; \
	  done

	find $(DESTDIR) -name '*.cmi' -exec touch '{}' ';'

	$(MAKE) logrotate
	rm -f $(DESTDIR)/var/run/ocsigen_command
	rm -f $(DESTDIR)/usr/share/ocsigen/ocsigenstuff/LICENSE


.PHONY: override_dh_auto_build
override_dh_auto_build:
# This directory, present in .orig.tar.gz, is created here because
# git doesn't handle empty directories
	mkdir -p doc
	$(MAKE) depend
	$(MAKE) all


.PHONY: override_dh_auto_clean
override_dh_auto_clean:
	[ ! -f Makefile.config ] || $(MAKE) distclean
	rm -Rf debian/examples xmlp4/newocaml/pp
	mkdir xmlp4/newocaml/pp


.PHONY: override_dh_auto_clean
override_dh_compress:
	dh_compress -X.ml


.PHONY: override_dh_install
override_dh_install:
	dh_install --list-missing


.PHONY: override_dh_ocaml
override_dh_ocaml:
	dh_ocaml \
	  --nodefined-map=libocsigen-ocaml-dev:Xmllexer \
	  --nodefined-map=libocsigen-xhtml-ocaml-dev:Xmllexer
